import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrBookpagearea {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  BookId!: IType<number, bigint>;
  BookPageId!: IType<number, bigint>;
  No?: string;
  Type!: number;
  GroupId!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrBookpageareaSchema = defineEntity({
  class: IcrBookpagearea,
  comment: '书页问题;',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    BookId: p.bigint().name('BookId').columnType('bigint').comment('书Id').index('idx_ICR_BookPageArea_01'),
    BookPageId: p.bigint().name('BookPageId').columnType('bigint').comment('书页id').index('idx_ICR_BookPageArea_02'),
    No: p.string().name('No').nullable().comment('题号'),
    Type: p.integer().name('Type').comment('题型'),
    GroupId: p.bigint().name('GroupId').columnType('bigint').comment('分组'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
